#define TEST(_name, _body) \
	long _name() { \
	long start; \
	long stop; \
	__asm__ __volatile__( \
	"rdtsc \n\t" \
	"movl %%eax , %%esi \n\t" \
	"movl $1000000 , %%ecx \n\t" \
	_body \
	"rdtsc \n\t" \
	"movl %%eax , %%edi \n\t" \
	"emms \n\t" \
	: "=S" (start), "=D" (stop) \
	: \
	: "memory" \
	); \
	return stop-start; \
}

#define RUN(_name, _count) \
	min = 0x7fffffff; \
	for(i=0; i<_count; ++i) { \
		int curr = _name(); \
		if(curr < min) min = curr; \
	} \
	printf(#_name ": %f\n", (double)min/1000000.0)
